

 {************************************* PRESENTATION ******************************************

 Cette logique resout le problme de LAMBERT (voir le cours spcifique). Il permet de dterminer
 une trajectoire elliptique ou hyperbolique connaissant les coordonnes du point de dpart et 
 d'arrive, ainsi que la dure du voyage.

 Le problme a toujours une solution  elliptique ( il peut quelquefois y en avoir 2 dans le cas
 d'un vol a plus d'un tour) ou une solution hyperbolique hyperbolique.

 NB : Les cas singuliers n'ont pas t abords ( Alignement des poInts, points confondus

 Les sorties sont possibles  l'cran et en fichier sur disque dur.

 Elles concernent :
	* Les rappels des donnes
	* Le type de vol elliptique ou hyperbolique
	* Le cas de vol ( voir la nomenclature en fin de fichier ou dernire page d'cran)
	* Les paramtres orbitaux
	* Les anomalies excentriques
	* La vitesse absolue au point de dpart* La vitesse absolue au point d'arrive
   * Les normes de ces vitesses

 Pour plus de renseignement voir le site ( adresse de novembre 2000 )

  http://artemmis.univ-mrs.fr/cybermeca/Formcont/mecaspa/index.htm

 et dans les cours "Missions lointaines", Problme de Lambert ......

 *********************** Sign : GUIZIOU Robert novembre 2000 *******************************}
 
{******************************* DEBUT DU PROGRAMME ****************************************}

{$A+,B-,D+,F-,G-,I+,L+,N-,R-,S+,V+,W+,X+}
{$M 8192,8192}

PROGRAM LAMBERT1;

{ *** Units utilises par le programme *** }

uses fonvect,fonscal,constype,wincrt;

label DEBUT_LOGIQUE;

{ *** DECLARATION DES VARIABLES VISIBLES DANS TOUT LE PROGRAMME *** }

VAR       RayonVecteurDepart,RayonVecteurArrivee,AxeI,AxeK,W,W12:vecteur;
	  VoyageLong, VoyageCourt,NumRep,Helios,ChoixVol,ChoixVol_Long_Court,NTour:integer;
	  LitRep,ch:char;
	  Mu,Lambda,Duree,DureeMini,DureeMiniN,AlphaNmin,Sol0Tour,SolNTour:real;
	  SensParcours,RetourDebut:boolean;
	  R1,R2,D,S,Angle,delta,Phi1,Phi2:real;
	  CAS_DE_VOl:Integer;
	  VectNod,VectExc,Vitesse1,Vitesse2,AxeW:vecteur;
	  DemiAxe,Exc,CTeta1,STeta1, Inclinaison, LongitudeVernale,ArgPerigee,Teta1:Real;
	  RayonPerigee,RayonApogee, NormeV1,NormeV2,CTeta2,STeta2:real;
	  Radial2, Orthoradial2:vecteur;
	  X,NomFichier,Nomdepart,Nomarrivee,Titre,TitreMission:string;
	  Texte,TexteFinal:Array[1..100] of String[85];
	  fichier:Text;
	  EcrireFichier,Premiere_ecriture:boolean;
	  ktexte:integer;
          retour:char;
{ *************************** DEFINITIONS DES FONCTIONS ************************************** }

	function TempsEllipseN(alpha,lambda:real;NTour:Integer):real;
		  var u,num,den,beta:real;

	 BEGIN
		 beta:=2*Arcsin(Lambda*sin(Alpha/2));
		 Num:=alpha-beta-sin(alpha)+sin(beta)+NTour*2*pi;
		 Den:=exp(3*Ln(sin(Alpha/2)));
		 u:=Num/Den;
		 TempsEllipseN:=u
	 END;
 { ---------------------------------------------------------------------------------------------}
	 function TempsEllipse0(alpha,lambda:real):real;
		  var u,num,den,beta:real;

	 BEGIN
		 beta:=2*Arcsin(Lambda*sin(Alpha/2));
		 Num:=alpha-beta-sin(alpha)+sin(beta);
		 Den:=exp(3*Ln(sin(Alpha/2)));
		 u:=Num/Den;
		 TempsEllipse0:=u
	 END;

 { ---------------------------------------------------------------------------------------------}
	 function TempsHyperbole(alpha,lambda:real):real;
		  var u,num,den,beta:real;

	 BEGIN
		 beta:=2*Argsh(Lambda*sinh(Alpha/2));
		 Num:=-alpha+beta+sinh(alpha)-sinh(beta);
		 Den:=exp(3*Ln(sinh(Alpha/2)));
		 u:=Num/Den;
		 TempsHyperbole:=u
	 END;

{ **********************************  FIN DES FONCTIONS  ***************************************** }

				     {****************}




{ *************************** DEFINITIONS DES PROCEDURES ************************************** }
 PROCEDURE  ECRITURE_FICHIER_PRELIMINAIRES;

  var ch:char;

BEGIN
   writeLn;
   writeLn('  ************************* PRELIMINAIRES **************************');
   WriteLn('  Ce logiciel rsout le PROBLEME DE LAMBERT dans tout type de ');
   WriteLn('  repres: Gocentriques quatoriaux...,Hliocentriques Ecliptiques... ');
   writeLn('  Gocentrique cliptique..., Plantocentriques.., Cartsien en gomtrie');
   writeLn('  pure etc...Ds lors les notions de "tir vers l''Est"," vers l''Ouest');
   writeLn('  peuvent ne plus avoir de sens gnral, suivant le repre choisi.');
   writeLn;
   writeLn('  Donc,la logique laisse l''utilisateur interprter les rsultats');
   writeLn('  bass sur un balayage du rayon vecteur et l''inclinaison orbitale i');
   writeLn('  dduite du signe du produit scalaire h.K'); 
   writeLn('      VOL COURT ( balayage du rayon vecteur<=180)');
   writeLn('      VOL LONG ( balayage du rayon vecteur>=180)');
   writeLn('      INCLINAISON <=90 <---> h.K>0');
   writeLn('           * Vers l''Est en gocentrique quatorial');
   writeLn('           * Sens des plantes en hliocentrique cliptique');
   writeLn('           * Sens  interprter pour les autres types de repres');
   writeLn('      INCLINAISON >90 <---> h.K<0 ');
   writeLn('           * Vers l''Ouest en gocentrique quatorial');
   writeLn('           * Sens contraire des plantes en hliocentrique cliptique');
   writeLn('           * Sens  interprter pour les autres types de repres');
   WriteLn;
   Writeln('  ******** Appuyez sur une touche pour effacer et continuer ********* ');
   ch:=readkey;   clrScr;
   WriteLn;
   writeLn('     ********************  DEBUT DES CALCULS   *********************');
END;



{--------------------------- DEBUT PROCEDURE ECRIURE_FICHIER ----------------------------------}
 PROCEDURE  ECRITURE_FICHIER;

 label INITIAL;

 VAR existe:boolean;
	  Reponse:char;
	  j,ReponseNum:integer;
 BEGIN

 INITIAL:


        { ------------  CREATION DU FICHIER RECEVANT LES RESULTATS ----------------}

	  writeln('  DONNEZ LE NOM DU FICHIER TEXTE DANS LEQUEL VOUS VOULEZ ECRIRE');
	  WriteLn('  CE FICHIER PEUT DEJA EXISTER . SINON NOUS LE CREONS.');
	  writeln('  Chemin complet (pas de nom long)---> Exemple : E:\Satellite\...\..\Liste.txt');
	  writeLn;
	  write('      NOM CHOISI (Chemin complet) = ');readln(nomfichier);WriteLn;

	  Assign(fichier,nomfichier);
	  {$I-}
	  Append(fichier);
	  {$I+}

	  { Rappel APPEND ouvre un fichier existant, s'il n'existe pas une erreur en rsulte, saisie par IORESULT qui
	  renvoie une valeur non nulle. Si tout est correct IORESULT vaut 0. Si le fichier est ouvert, le pointeur
	  pointe la fin du fichier qui reste ouvert

	  APPEND a t choisie pour viter de dtruire par erreur un fichier existant.}

	  existe:=(IORESULT<>0);

		If existe then
		  begin
			 Write('     LE FICHIER N''EXISTE PAS, VOULEZ-VOUS LE CREER ? (o/n)');
			 readln(reponse);
			 If ((reponse<>'n') and (reponse<>'N') and (Reponse<>'o') and (reponse<>'O')) then DoneWinCrt;
			 If ((reponse='o') or (reponse='O')) then
				Begin
				 Assign(fichier,nomfichier);
				 {$I-}
				 Rewrite(fichier); {Fichier cr ou dtruit et recr, et ouvert en position criture
										  Le pointeur de fichier est positionn en dbut de fichier vide}
				 {$I+}
				 If (IORESULT<>0) Then
					 begin
					  WriteLn('  UN LECTEUR OU UN REPERTOIRE ASSIGNE N''EXISTE CERTAINEMENT PAS');WriteLn;
					  GoTo INITIAL;
					 end;
				 Close(Fichier);
				End;
			 If ((reponse='n') or (reponse='N')) then EcrireFichier:=False;

		  end;
		  If Not(existe) then
			 Begin
				 Writeln('      UN FICHIER DU MME NOM A ETE TROUVE ?????  ');
				 Write('      FAUT-IL CONTINUER ???? (o/n)');readln(reponse);
				 If not((reponse='o') or (reponse='O')) then
				  Begin
					 Close(Fichier);
					 exit;
				  End;

			 End;
	  {  -*-*-*-*-*-*-*-* ECRITURE DANS FICHIER SUIVANT LE CAS *-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*}

		WriteLn;
		If Ntour>0 Then ktexte:=2*ktexte-22;

		If not(existe) then
		Begin
			 WriteLn('     SOUHAITEZ-VOUS ECRASER LE FICHIER EXISTANT ( Choisir --> 1 )  ??');
			 Write('     SOUHAITEZ-VOUS AJOUTER AU FICHIER EXISTANT ( Choisir --> 2 )  ??');
			 Write(' Reponse? ');ReadLn(ReponseNum);


			 If ReponseNum= 1 then Rewrite(fichier);
			 If ReponseNum= 2 then Append(fichier);
		End;

		If existe then Append(Fichier);

		WriteLn;



		For j:=1 To 4 do
		Begin
                  if NOT(TexteFinal[j]=' oooooooooo NOTEZ ET APPUYEZ SUR UNE TOUCHE POUR CONTINUER oooooooooooooooooo') then
		  writeLn(fichier,TexteFinal[j]);
		End;

                WRITELN(Fichier,'  DEPART :',Nomdepart);
                WRITELN(Fichier,'  ARRIVEE :',NomArrivee);

                For j:=5 To ktexte do
		Begin
                  if NOT(TexteFinal[j]=' oooooooooo NOTEZ ET APPUYEZ SUR UNE TOUCHE POUR CONTINUER oooooooooooooooooo') then
		  writeLn(fichier,TexteFinal[j]);
		End;

		{ ***** ------------------  DESCRIPTION DES CAS DE VOL --------------------------********}
		WRITELN(Fichier,' --------------------------------------------------------');
		WRITELN(Fichier,'');
		WRITELN(Fichier,'                   DESCRIPTION DES CAS DE VOL');
		WRITELN(Fichier,'  CONVENTIONS ( Redondantes ):');
		WRITELN(Fichier,'     P- <--> Avant prige   P+ <--> Aprs prige ');
		WRITELN(Fichier,'     A- <--> Avant apoge    A+ <--> Aprs Apoge ');
		WRITELN(Fichier,'     M- <--> Monte          D  <--> Descente');
		WRITELN(Fichier,'     M- <--> Monte          D  <--> Descente');
		WRITELN(Fichier,'     G+ <--> Angle>180      G- <--> Angle<180');

		WRITELN(Fichier,'     CAS 1 Ellipse :R1<R2 G- Dpart M & P+, Arrive M & A- ');
		WRITELN(Fichier,'     CAS 2 Ellipse :R1<R2 G- Dpart M & P+, Arrive D & P- & A+ ');
		WRITELN(Fichier,'     CAS 3 Ellipse :R1<R2 G+ Dpart M & P+, Arrive D & P- & A+ ');
		WRITELN(Fichier,'     CAS 4 Ellipse :R1<R2 G- Dpart D & P-, Arrive D & P- & A+ ');
		WRITELN(Fichier,'     CAS 5 Ellipse :R1<R2 G- Dpart D & P-, Arrive M & P+ & A- ');
		WRITELN(Fichier,'     CAS 6 Ellipse :R1>R2 G- Dpart M & P+, Arrive D & P- & A+ ');
		WRITELN(Fichier,'     CAS 7 Ellipse :R1>R2 G- Dpart D & A+, Arrive D & P- ');
		WRITELN(Fichier,'     CAS 8 Ellipse :R1>R2 G+ Dpart M & P+ & A-, Arrive M & P+ & A-');
		WRITELN(Fichier,'     CAS 9 Ellipse :R1>R2 G+ Dpart D & A+ & P-, Arrive M & P+ & A- ');
		WRITELN(Fichier,'     CAS 10 Ellipse  :R1>R2 G- Dpart D & A+ & P-, Arrive D & P- & A+ ');

		WRITELN(Fichier,'     CAS 11 Hyperbole  :R1<R2 G- Dpart M & P+, Arrive M & P+');
		WRITELN(Fichier,'     CAS 12 Hyperbole  :R1<R2 G- Dpart D & P-, Arrive M & P+');
		WRITELN(Fichier,'     CAS 13 Hyperbole  :R1<R2 G+ Dpart D & P-, Arrive M & P+');
		WRITELN(Fichier,'     CAS 14 Hyperbole  :R1>R2 G- Dpart D & P-, Arrive D & P-');
		WRITELN(Fichier,'     CAS 15 Hyperbole  :R1>R2 G- Dpart D & P-, Arrive M & P+');
		WRITELN(Fichier,'     CAS 16 Hyperbole  :R1>R2 G+ Dpart D & P-, Arrive M & P+');
                WRITELN(FICHIER,' ');
                WRITELN(FICHIER,'     oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo');
                WRITELN(FICHIER,' ');
		close(fichier);

 END;
{ -------------------------------  FIN  PROCEDURE ECRITURE_FICHIER  ---------------------------------}


{---------------------------------- DEBUT DE PROCEDURE DEMANDES   ------------------------------------}

PROCEDURE DEMANDES;

label RECOM;

Var reponse:char;


BEGIN
RECOM:
        EcrireFichier:=True;
	WriteLn;
	Write('     VOULEZ-VOUS ECRIRE LES RESULTATS DANS UN FICHIER TEXTE ? (o/n)'); readln(reponse);
	If ((reponse='n') or (reponse='N')) then  EcrireFichier:=False;
        if Not((reponse='o') or (reponse='O')) and Not((reponse='n') or (reponse='N')) then goto RECOM;
	WriteLn;


{-------- Corps central ---------------}

        WriteLn('  Donnez un nom  votre mission ( 31 caractres max ou rien )');
        Write('  NOM MISSION =  ');ReadLn(TitreMission);
        WriteLn;
        writeLn;
        writeLn('  Donnez un nom au point de dpart: P1 ou Terre ou Mars ou rien');
        write('  NOM1 du point de dpart? =  ');ReadLn(Nomdepart);writeLn;
        WriteLn('  Donnez un nom au point d''arrive: P2 ou Terre ou mars ou rien ');
        Write('  NOM2 du point d''arrive? =  ');ReadLn(Nomarrivee);
        writeLn;
        WriteLn('   *********************   CHOIX DU CORPS CENTRAL   ********************');
        WriteLn('     Vol gocentrique : 0 ');
	WriteLn('     Vol hliocentrique : 1       ');
        WriteLn('     Vol autour de mars: 2 ');
        WriteLn('     Vol autour d''une autre plante: 3 '); writeLn;
	Write('     Votre choix du corps central :');Read(Helios);
	WriteLn;
	If Helios=1 then Mu:=13.271244e10;
	If Helios=0 then Mu:=39.860064e4;
        If Helios=2 then Mu:=4.305e4;
        If Helios=3 then
           begin
              Write('     Donnez sa constante de gravitation en km3/s2 :');ReadLn(Mu);
           end;
        if helios>1 then helios:=0	;
        writeLn;
      

{-------- Coordonnes des points ---------------}

 RetourDebut:=False;
 While RetourDebut=False do BEGIN

        writeLn('     Donnez les trois coordonnes du point de dpart en km, (exemple 25e6)');
	Write('        X1 = ');ReadLn(RayonVecteurDepart[1]);
	Write('        Y1 = ');ReadLn(RayonVecteurDepart[2]);
	Write('        Z1 = ');ReadLn(RayonVecteurDepart[3]);
	writeLn;
	WriteLn('     Donnez les trois coordonnes du point d''arrive en km, (exemple 125e6)');
	Write('        X2 = ');ReadLn(RayonVecteurArrivee[1]);
	Write('        Y2 = ');ReadLn(RayonVecteurArrivee[2]);
	Write('        Z2 = ');ReadLn(RayonVecteurArrivee[3]);  


	

	{****************** VALEURS D'ESSAI A SELECTIONNER EN RETIRANT LES ACCOLADES   *******************}

         { CAS ROSETTA Terre-Mars  plus d'un tour}

	{RayonVecteurdepart[1]:=-53.484e6;
	RayonVecteurdepart[2]:=137.056e6;
	RayonVecteurdepart[3]:=-8.876e6;
	RayonVecteurarrivee[1]:=208.193e6;
	RayonVecteurArrivee[2]:= 3.7176e6;
	RayonVecteurArrivee[3]:= -5.037e6;   OK OK OK OK }



	{  CAS1   a=200e6    e=0.5  DT=41.032 jours, fi1=1.047, fi2=1.5708}

	{RayonVecteurdepart[1]:=150e6;
	RayonVecteurdepart[2]:=0;
	RayonVecteurdepart[3]:=1e6;
	RayonVecteurarrivee[1]:=173.2008e6;
	RayonVecteurArrivee[2]:= 100e6;
	RayonVecteurArrivee[3]:= 0e6;   OK OK OK OK }


	{ CAS2   a=200e6    e=0.5  DT=413.203 jours,  fi1=1.0472,  fi2=4.7124}

	{RayonVecteurdepart[1]:=150e6;
	RayonVecteurdepart[2]:=0;
	RayonVecteurdepart[3]:=0;
	RayonVecteurarrivee[1]:=-173.2008e6;
	RayonVecteurArrivee[2]:= 100e6;
	RayonVecteurArrivee[3]:= 0e6;   OK OK OK OK }



	{CAS3 a=200e6    e=0.5  DT=468.395 jours,    fi1=0, fi2=4.71239}

	{RayonVecteurdepart[1]:=0e6;
	RayonVecteurdepart[2]:=-100e6;
	RayonVecteurdepart[3]:=0;
	RayonVecteurarrivee[1]:=-173.2008e6;
	RayonVecteurArrivee[2]:= 100e6;
	RayonVecteurArrivee[3]:= 0e6;     OK OK OK OK }

	{CAS4    a=200e6    e=0.5  DT=523.5868 jours, fi1=5.236,  fi2=4.7124}

	{RayonVecteurdepart[1]:=-150e6;
	RayonVecteurdepart[2]:=0e6;
	RayonVecteurdepart[3]:=0;
	RayonVecteurarrivee[1]:=-173.20080e6;
	RayonVecteurArrivee[2]:= 100e6;
	RayonVecteurArrivee[3]:= 0e6;   OK OK OK OK }

	{CAS5 a=200e6   OK OK OK OK  e=0.5  DT=151.4158 jours,   fi1=5.236,  fi2=1.57..}
	{RayonVecteurdepart[1]:=-150e6;
	RayonVecteurdepart[2]:=0e6;
	RayonVecteurdepart[3]:=0;
	RayonVecteurarrivee[1]:=173.2008e6;
	RayonVecteurArrivee[2]:= 100e6;
	RayonVecteurArrivee[3]:= 0e6;     }

	{CAS6   a=200e6    e=0.5  DT=413.203 jours,   fi1=1.57.., fi2=5.236}
	{RayonVecteurdepart[1]:=173.2008e6;
	RayonVecteurdepart[2]:=100e6;
	RayonVecteurdepart[3]:=0;
	RayonVecteurarrivee[1]:=-150e6;
	RayonVecteurArrivee[2]:= 0e6;
	RayonVecteurArrivee[3]:= 0e6;    OK OK OK OK}




	{CAS7   a=200e6    e=0.5  DT=41.023 jours,   fi1=4.7124.., fi2=5.236}

	{RayonVecteurdepart[1]:=-173.2008e6;
	RayonVecteurdepart[2]:=100e6;
	RayonVecteurdepart[3]:=0;
	RayonVecteurarrivee[1]:=-150e6;
	RayonVecteurArrivee[2]:= 0e6;
	RayonVecteurArrivee[3]:= 0e6;  OK OK OK OK}
	writeLn;

	{CAS8   a=200e6    e=0.5  DT=523.5868 jours,   fi1=1.57...., fi2=1.047}

	{RayonVecteurdepart[1]:=173.2008e6;
	RayonVecteurdepart[2]:=100e6;
	RayonVecteurdepart[3]:=0;
	RayonVecteurarrivee[1]:=150e6;
	RayonVecteurArrivee[2]:= 0e6;
	RayonVecteurArrivee[3]:= 0e6;} {  OK OK OK OK}

	{CAS9   a=200e6    e=0.5  DT=151.4158 jours,   fi1=4.7124.., fi2=1.047}

	{RayonVecteurdepart[1]:=-173.2008e6;
	RayonVecteurdepart[2]:=100e6;
	RayonVecteurdepart[3]:=0;
	RayonVecteurarrivee[1]:=150e6;
	RayonVecteurArrivee[2]:= 0e6;
	RayonVecteurArrivee[3]:= 0e6;  OK OK OK OK}

	{CAS10   a=200e6    e=0.5  DT=96.2238 jours,   fi1=4.7124.., fi2=0}

	{RayonVecteurdepart[1]:=-173.2008e6;
	RayonVecteurdepart[2]:=100e6;
	RayonVecteurdepart[3]:=0;
	RayonVecteurarrivee[1]:=0.0000000001e6;
	RayonVecteurArrivee[2]:=-100e6;
	RayonVecteurArrivee[3]:= 0e6;  OK OK OK OK}

        {CAS11 CAS11  CAS11           OK OK OK OK                      CAS11 CAS11  CAS11
                      a=200e6    e=0.5  DT=462.11848 jours,   fi1=1.5707963.., fi2=6.143559}

	{RayonVecteurdepart[1]:=173.2008e6;
	RayonVecteurdepart[2]:=100e6;
	RayonVecteurdepart[3]:=0;
	RayonVecteurarrivee[1]:=-24.105e6;
	RayonVecteurArrivee[2]:=-98.054e6;
	RayonVecteurArrivee[3]:= 0e6;      }

        {CAS12 CAS12  CAS12           OK OK OK OK                      CAS12 CAS12  CAS12
                      a=200e6    e=0.5  DT=102.52152 jours,   fi1=6.143559.., fi2=1.5707963}

	{RayonVecteurdepart[1]:=-24.105e6;
	RayonVecteurdepart[2]:=-98.054e6;
	RayonVecteurdepart[3]:=0;
	RayonVecteurarrivee[1]:=173.2008e6;
	RayonVecteurArrivee[2]:=100e6;
	RayonVecteurArrivee[3]:= 0e6;   }



        {  Mission Ulysses
        RayonVecteurdepart[1]:=145.53e6;
	RayonVecteurdepart[2]:=34.38e6;
	RayonVecteurdepart[3]:=0;
	RayonVecteurarrivee[1]:=-749.2e6;
	RayonVecteurArrivee[2]:=302e6;
	RayonVecteurArrivee[3]:=15.53e6;OK OK OK }


	writeLn;


        { Hyperbole   VOL N 18        OK OK OK OK
         e=(2)^0.5,a=20000,R1=10000,R2=20000  	Phi2=0.88137, Phi1= -0.34657, DT=3074.32  ///// TERRE}

	{RayonVecteurdepart[1]:=7071.7;
	RayonVecteurdepart[2]:=-7071.7;
	RayonVecteurdepart[3]:=0;
	RayonVecteurarrivee[1]:=0;
	RayonVecteurArrivee[2]:=20000;
	RayonVecteurArrivee[3]:=0;      }


        { Hyperbole   VOL N 17     OK OK OK OK
         e=(2)^0.5,a=20000,R1=10000,R2=20000, Phi2=0.88137, Phi1= 0.34657,    DT=1699  ///// TERRE}

	{RayonVecteurdepart[1]:=7071.7;
	RayonVecteurdepart[2]:=7071.7;
	RayonVecteurdepart[3]:=0;
	RayonVecteurarrivee[1]:=0;
	RayonVecteurArrivee[2]:=20000;
	RayonVecteurArrivee[3]:=0;      }

        { Hyperbole   VOL N 16      OK OK OK OK
           e=(2)^0.5,a=20000,R1=23645,     R2=23645,  Phi2=0.88137, Phi1=-1     DT=5352.7  ///// TERRE}

	{RayonVecteurdepart[1]:=-2577.3;
	RayonVecteurdepart[2]:=-23504;
	RayonVecteurdepart[3]:=0;
	RayonVecteurarrivee[1]:=0;
	RayonVecteurArrivee[2]:=20000;
	RayonVecteurArrivee[3]:=0;    }


        { Hyperbole   VOL N 15        OK OK OK OK
         e=(2)^0.5,a=20000,R1=10000,R2=20000  	Phi2=0.88137, Phi1= -0.34657, DT=3074.32  ///// TERRE}

	{RayonVecteurdepart[1]:=0;
	RayonVecteurdepart[2]:=-20000;
	RayonVecteurdepart[3]:=0;
	RayonVecteurarrivee[1]:=7071.7;
	RayonVecteurArrivee[2]:=7071.7;
	RayonVecteurArrivee[3]:=0;      }



        { Hyperbole   VOL N 14      OK OK OK OK
         e=(2)^0.5,a=20000,R1=20000,R2=23645,
	Phi2=-0.88137, Phi1=-1     DT=578.7  ///// TERRE}

	{RayonVecteurdepart[1]:=-2577.3;
	RayonVecteurdepart[2]:=-23504;
	RayonVecteurdepart[3]:=0;
	RayonVecteurarrivee[1]:=0;
	RayonVecteurArrivee[2]:=-20000;
	RayonVecteurArrivee[3]:=0;      }


        { Hyperbole   VOL N 13      OK OK OK OK
           e=(2)^0.5,a=20000,R1=23645,     R2=23645,  Phi1=-0.88137, Phi2=1     DT=5352.7  ///// TERRE}

	{RayonVecteurdepart[1]:=0;
	RayonVecteurdepart[2]:=-20000;
	RayonVecteurdepart[3]:=0;
	RayonVecteurarrivee[1]:=-2577.3;
	RayonVecteurArrivee[2]:=23504;
	RayonVecteurArrivee[3]:=0;     }


        WriteLn('   ********************* CHOIX DU TYPE DE VOL  ******************************');



 {---    Test de non colinarit et calcul du produit vectoriel W12=R1^R2----------}

	 Prodvect(RayonVecteurDepart,RayonVecteurArrivee,W12);
	 SensParcours:=W12[3]>0;
	 If norm(W12)>0 then RetourDebut:=True;
	 If norm(W12)=0 then
		begin
			writeLn('     LES POINTS P1 P2 ET LE CORPS CENTRAL SONT ALIGNES, CAS SINGULIER,');
			WriteLn('     Donnez les positions   nouveau');
			RetourDebut:=False;
			WriteLn;
		end;

	END;

 END;
{---------------------------   FIN DE PROCEDURE DEMANDES  ----------------------------------------------}




{-------------------------- DEBUT DE PROCEDURE INITIALISATION---------------------------------------------}

 PROCEDURE INITIALISATION;

 LABEL CHOIX_VOL;

 var logi1, logi2, Logi3 : boolean;
     scal:real;

 BEGIN
	 { -------------- DEFINITION AXES I et K ----------------}
	 AxeI[1]:=1;AxeI[2]:=0;AxeI[3]:=0;
	 AxeK[1]:=0;AxeK[2]:=0;AxeK[3]:=1;
	 { ------------------------------------------------}
	 R1:=norm(RayonVecteurDepart);R2:=norm(RayonVecteurArrivee);
	 Angle:=angvect(RayonVecteurDepart,RayonVecteurArrivee);
	 D:=sqrt(sqr(R1)+sqr(R2)-2*R1*R2*cos(angle));
	 S:=(R1+R2+D)/2 ;

	 {-------- Choix du vol long ou court ----------}
 CHOIX_VOL:

         If Helios=1 then

		BEGIN

		 If SensParcours then
			Begin
				WriteLn('  CAS 1 :Vol court hliocentrique, sens gnral des plantes semble possible');
				WriteLn('  CAS 2 :Vol long hliocentrique, sens contraire des plantes semble possible');
				WriteLn;
				Write('     QUEL CHOIX OPEREZ VOUS ? ( 1 ou 2 )  '); ReadLn(ChoixVol_Long_Court); WriteLn;
			End;


		 If Not(sensParcours)then
			Begin
			  WriteLn('  CAS 3 :Un vol long  hliocentrique, sens gnral des plantes semble possible');
			  WriteLn('  CAS 4 :Un vol court hliocentrique, sens contraire des plantes semble possible');
			  WriteLn;
			  Write('     QUEL CHOIX OPEREZ VOUS ? ( 3 ou 4 )  '); ReadLn(ChoixVol_Long_Court); WriteLn;
			End;

		END;

	 If Helios=0 then

		BEGIN

		  If SensParcours then
			 Begin
			  WriteLn('  CAS1 :Un vol court, Inclinaison <=90, semble possible');
			  WriteLn('  CAS2 :Un vol long , Inclinaison>90, semble possible');
			  WriteLn;
			  Write('     QUEL CHOIX OPEREZ VOUS ? ( 1 ou 2 )  '); ReadLn(ChoixVol_Long_Court); WriteLn;
			 End;

		  If Not(sensParcours)then
			 Begin
			  WriteLn('  CAS 3 :Un vol long, Inclinaison <=90, semble possible');
			  WriteLn('  CAS 4 :Un vol court, Inclinaison >90, semble possible');
			  WriteLn;
			  Write('     QUEL CHOIX OPEREZ VOUS ? ( 3 ou 4 )  '); ReadLn(ChoixVol_Long_Court); WriteLn;
			 End;
		  WriteLn('****************************************************************************');

		END;
          logi1:=((ChoixVol_Long_Court=1) or  (ChoixVol_Long_Court=2));
          logi2:=((ChoixVol_Long_Court=3) or (ChoixVol_Long_Court=4));
          if not(logi1 or logi2) then

          begin
          writeLn('                  **** ERREUR DE CHOIX ***  RECOMMENCEZ ****');writeLn;
          goto CHOIX_VOL;
          end;

	 {----------------------------------------------}

		Write('     DONNEZ LE NOMBRE DE TOURS EVENTUELS AVANT VOYAGE EFFECTIF (NTour<4) = ');ReadLn(NTour);WriteLn;

	 {------------  CALCUL DE DELTA ----------------}

	 If   (ChoixVol_Long_Court=1) or (ChoixVol_Long_Court=4) then
		Begin
			Delta:=Angle;
			W:=W12;
			Lambda:=sqrt(R1*R2)*cos(Delta/2)/S;
		End;
	 If   (ChoixVol_Long_Court=2) or (ChoixVol_Long_Court=3) then
		Begin
			delta:=2*pi-Angle;
			Scalvect(-1,W12,W);
			Lambda:=sqrt(R1*R2)*cos(Delta/2)/S;
		End
	{----------------------------------------------}

 END;

{---------------------------       FIN DE PROCEDURE  INITIALISATION  -----------------------------------------}


{                                  ********************************}


{------------------------------DEBUT DE PROCEDURE SOLUTION_ELLIPTIQUE --------------------------------------}

 PROCEDURE SOLUTION_ELLIPTIQUE;

 Var Xmin,Xmax,AlphaMin,dx,Prod:real;
	  i,k:integer;
	  F,X:array[1..11] of real;


BEGIN
	  { -----------------------  CAS ELLIPTIQUE MOINS D'UN TOUR ---------------------}

	  { **NB **:TOUS LES CALCULS AVEC LE TEMPS EN JOURS}

	  If Helios=1 then
	  BEGIN
		  Write('     Donnez la dure du voyage en jours dcimaux');
		  Write('     Dure = ');ReadLn(Duree);WriteLn;
	  END;

	  If Helios=0 then
	  BEGIN
		  Write('     Donnez la dure du voyage en secondes');
		  Write('     Dure = ');ReadLn(Duree);WriteLn;
		  Duree:=Duree/86400; { Conversion en jours dcimaux}
	  END;

	  If Ntour=0 then
	  Begin
		  DureeMini:=(1-lambda*lambda*lambda)*sqrt(2*exp(3*Ln(S))/Mu)/3/86400;
		  If Helios=1 then WriteLn('     La duree minimale est de ',dureemini:6:2,'jours');WriteLn;
		  If Helios=0 then
			 BEGIN
          DureeMini:=DureeMini*86400; { En secondes pour crire }
			 WriteLn('     La duree minimale est de ',dureemini:6:2,' secondes');
          DureeMini:=DureeMini/86400; { Retour en jours pour les calculs}
			 WriteLn;
			 END;

		  If ((Duree>Dureemini) and (NTour=0)) then WriteLn('     UN VOYAGE ELLIPTIQUE A MOINS D''UN TOUR EST POSSIBLE') ;
		  If (Not(Duree>Dureemini) and (NTour=0)) then WriteLn('     UN VOYAGE ELLIPTIQUE A MOINS D''UN TOUR EST IMPOSSIBLE') ;
		  WriteLn;
	  End;

	  {---------------------------Fin Cas Elliptique 0 tour--------------------------}

	  {-----------------------     CAS ELLIPTIQUE A N TOURS --------------------------}

	  { ----- Calcul minimum F(alpha) N tours-------}

	If NTour>0 then

	BEGIN
	  Xmin:=0.1;Xmax:=2*pi-0.1;
	  For k:=1 to 20 do
		BEGIN
		  For i:=0 To 10 do
			Begin
			 dx:=(Xmax-Xmin)/10;
			 X[i]:=Xmin+i*dx;
			 F[i]:=TempsEllipseN(X[i],Lambda,NTour);
			end;
		 For i:=1 To 9 do
			Begin
			 Prod:=(F[i-1]-F[i])*(F[i+1]-F[i]);
			 If Prod>=0 then
				Begin
				 Xmin:=X[i-1];Xmax:=X[i+1];
				 If (Xmax-Xmin)<1e-5 then AlphaNmin:=(Xmax+Xmin)/2;
				end;
			end;

		END;
	  {------Fin du calcul minimum --------}

	If Helios=1 then
	  BEGIN
		 DureeMiniN:=sqrt(exp(3*Ln(S))/Mu/8)/86400*TempsEllipseN(AlphaNmin,lambda,NTour);
		 WriteLn('     DUREE MINIMALE A ',Ntour,' TOUR(S), EN JOURS = ',DureeMiniN:7:2);
		 WriteLn;
		 If DureeMiniN>Duree then WriteLn('     Un voyage  ', Ntour,'  tour(s) est impossible');
		 If DureeMiniN<=Duree then WriteLn('     Un voyage  ', Ntour,'  tour(s) est possible');
		 WriteLn;
		 DureeMini:=DureeMiniN;
	 END;
	If Helios=0 then
	  BEGIN
		 DureeMiniN:=sqrt(exp(3*Ln(S))/Mu/8)*TempsEllipseN(AlphaNmin,lambda,NTour); {  En secondes pour crire}
		 WriteLn('     DUREE MINIMALE A ',Ntour,' TOUR(S)', 'DUREE MIMINI= ',DureeMiniN:7:2,' secondes');
		 DureeMiniN:=DureeMiniN/86400; { Retour en jours pour les calculs }
		 WriteLn;
		 If DureeMiniN>Duree then WriteLn('     Un voyage  ', Ntour,'  tour(s) est impossible');
		 If DureeMiniN<=Duree then WriteLn('     Un voyage  ', Ntour,'  tour(s) est possible');
		 WriteLn;
		 DureeMini:=DureeMiniN;
	  END;

	END;


 END;

  {----------------------------       Fin de Cas Elliptique NTour>0      ------------------------------------------}


 {---------------------------       FIN DE PROCEDURE  SOLUTION_ELLIPTIQUE  -----------------------------------------}


 {---------------------------  DEBUT DE PROCEDURE  SOLUTION_EQUATION_ELLIPTIQUE_0_TOUR  -----------------------------------}

 PROCEDURE SOLUTION_EQUATION_ELLIPTIQUE_0_TOUR;

 Var TempsReduit,Xmin,Xmax,dx,Prod:real;
	  Test:boolean;
	  i:integer;
	  F,X:array[1..11] of real;


 BEGIN

 TempsReduit:=Duree*86400/(sqrt(exp(3*Ln(S))/Mu/8));
 Xmax:=2*pi-0.1; Xmin:=0.1;Test:=True;
  While Test=True do
	Begin
	  If TempsEllipse0(Xmin,lambda) >=TempsReduit Then  Xmin:=Xmin/2;
	  If TempsEllipse0(Xmin,lambda) < TempsReduit Then  Test:=False;
	End;

	Test:=True;
 While Test=True do
	Begin
	  If TempsEllipse0(Xmax,lambda) <=TempsReduit Then  Xmax:=(2*pi+Xmax)/2;
	  If TempsEllipse0(Xmax,lambda) > TempsReduit Then  Test:=False;
	End;



	{-------  Rsolution   -------------}
 Test:=True;
 While Test=True do
  BEGIN
		dx:=(Xmax-Xmin)/10;
		For i:=1 To 11 do
		Begin
			X[i]:=Xmin+(i-1)*dx;
			F[i]:=TempsEllipse0(X[i],Lambda);
		end;
		For i:=1 To 10 do
		Begin
			Prod:=(TempsReduit-F[i])*(TempsReduit-F[i+1]);
			If Prod<=0 then
			begin
			 Xmin:=X[i] ;Xmax:=X[i+1];
			end;
		end;
	 If ((Xmax-Xmin) <1e-7) Then
	  begin
		 Sol0Tour:=(Xmax+Xmin)/2; Test:=False;
	  End;
  END;

	{-----------------------------------}

 END;
 {--------------------- FIN DE PROCEDURE  SOLUTION_EQUATION_ELLIPTIQUE_0_TOUR  ---------------------------------}



  {--------------------  DEBUT DE PROCEDURE  PREMIER_SOLUTION_EQUATION_ELLIPTIQUE_N_TOUR  --------------------------}

 PROCEDURE PREMIERE_SOLUTION_EQUATION_ELLIPTIQUE_N_TOUR;

 Var TempsReduit,Xmin,Xmax,dx,Prod:real;
	  Test:boolean;
	  i:integer;
	  F,X:array[1..11] of real;


 BEGIN

 TempsReduit:=Duree*86400/(sqrt(exp(3*Ln(S))/Mu/8));


 { ------- CALCUL DE Xmin et Xmax POUR DEMARRER LE CALCUL A DROITE DE AlphaminN -------------------}

  Xmax:=2*pi-0.1; Xmin:=(AlphaNmin+Xmax)/2;Test:=True;

  While Test=True do
  Begin
	  If TempsEllipseN(Xmin,lambda,NTour) >=TempsReduit Then  Xmin:=(Xmin+AlphaNmin)/2;
	  If TempsEllipseN(Xmin,lambda,NTour) < TempsReduit Then  Test:=False;
	End;

	Test:=True;
 While Test=True do
	Begin
	  If TempsEllipseN(Xmax,lambda,NTour) <=TempsReduit Then  Xmax:=(2*pi+Xmax)/2;
	  If TempsEllipseN(Xmax,lambda,NTour) > TempsReduit Then  Test:=False;
	End;

	{-------  Rsolution   -------------}
 Test:=True;
 While Test=True do
  BEGIN
		dx:=(Xmax-Xmin)/10;
		For i:=1 To 11 do
		Begin
			X[i]:=Xmin+(i-1)*dx;
			F[i]:=TempsEllipseN(X[i],Lambda,NTour);
		end;
		For i:=1 To 10 do
		Begin
			Prod:=(TempsReduit-F[i])*(TempsReduit-F[i+1]);
			If Prod<=0 then
			begin
			 Xmin:=X[i] ;Xmax:=X[i+1];
			end;
		end;
	 If ((Xmax-Xmin) <1e-7) Then
	  begin
		 SolNTour:=(Xmax+Xmin)/2; Test:=False;
	  End;
  END;

	{-------Fin rsolution ------}

 END;
 {--------------------------- FIN DE PROCEDURE  SOLUTION_EQUATION_ELLIPTIQUE_N_TOUR  ---------------------------------}
 									  { ****************************************************}

 {-----------------------  DEBUT DE PROCEDURE  DEUXIEME_SOLUTION_EQUATION_ELLIPTIQUE_N_TOUR  --------------------------}

 PROCEDURE DEUXIEME_SOLUTION_EQUATION_ELLIPTIQUE_N_TOUR;

 Var TempsReduit,Xmin,Xmax,dx,Prod:real;
	  Test:boolean;
	  i:integer;
	  F,X:array[1..11] of real;


 BEGIN

 TempsReduit:=Duree*86400/(sqrt(exp(3*Ln(S))/Mu/8));


 { ------- CALCUL DE Xmin et Xmax POUR DEMARRER LE CALCUL A DROITE DE AlphaminN -------------------}

  Xmin:=0.1; Xmax:=(AlphaNmin+Xmin)/2;Test:=True;

  While Test=True do
  Begin
	  If TempsEllipseN(Xmin,lambda,NTour) <=TempsReduit Then  Xmin:=Xmin/2;
	  If TempsEllipseN(Xmin,lambda,NTour) > TempsReduit Then  Test:=False;
	End;

	Test:=True;
 While Test=True do
	Begin
	  If TempsEllipseN(Xmax,lambda,NTour) >= TempsReduit Then  Xmax:=(Xmax+AlphaNmin)/2;
	  If TempsEllipseN(Xmax,lambda,NTour) < TempsReduit Then  Test:=False;
	End;

	{-------  Rsolution   -------------}
 Test:=True;
 While Test=True do
  BEGIN
		dx:=(Xmax-Xmin)/10;
		For i:=1 To 11 do
		Begin
			X[i]:=Xmin+(i-1)*dx;
			F[i]:=TempsEllipseN(X[i],Lambda,NTour);
		end;
		For i:=1 To 10 do
		Begin
			Prod:=(TempsReduit-F[i])*(TempsReduit-F[i+1]);
			If Prod<=0 then
			begin
			 Xmin:=X[i] ;Xmax:=X[i+1];
			end;
		end;
	 If ((Xmax-Xmin) <1e-7) Then
	  begin
		 SolNTour:=(Xmax+Xmin)/2; Test:=False;
	  End;
  END;

	{-------Fin rsolution ------}

 END;
 {--------------------------- FIN DE PROCEDURE  SOLUTION_EQUATION_ELLIPTIQUE_N_TOUR  ---------------------------------------}



 {--------------------------- DEBUT DE PROCEDURE  CALCULS_GENERAUX_ELLIPSE  ---------------------------------------}

  PROCEDURE CALCULS_GENERAUX_ELLIPSE(Var exc,DemiAxe,Phi1,Phi2:real);

  VAR betasol,Alphasol,Psi,Phi,A,B:real;
		f11,f12,f21,f22:real;

  BEGIN

	 If NTour=0 then Alphasol:=Sol0Tour;
	 If NTour>0 then Alphasol:=SolNTour;

	 {---------------  Calcul de Phi et Psi -------- pas de pb ---}

	 Betasol:=2*Arcsin(Lambda*sin(AlphaSol/2));

	 Phi:=(AlphaSol+BetaSol)/2;
	 Psi:=(AlphaSol-BetaSol)/2;

	 writeLn('    PSI = ',psi,'    PHI = ', phi);
	 { ------------------------------------------------------------}

	 { ------- EXCENTRICITE ET DEMI GRAND AXE a ------Pas de pb ---}

	 exc:=sqrt(sqr(cos(Phi))+sqr((R1-R2)*sin(Phi)/D)); WriteLn('    Excentricit =', exc);
	 DemiAxe:=S/(1-cos(AlphaSol));  WriteLn('    Demi-Grand axe =', DemiAxe);

	 {-------------------------------------------------------------}


			{***   Calcul phi1, Phi2    ***}
			 f11:=ArcCos((1-R1/DemiAxe)/exc);
			 f12:=2*pi-f11;
			 f21:=ArcCos((1-R2/DemiAxe)/exc);
			 f22:=2*pi-f21;

			 if abs(f21-f11-2*Psi)<1e-4 then
			  begin
			  phi1:=f11;phi2:=f21;
			  end;
			 if abs(f21-f12-2*Psi)<1e-4 then
			  begin
			  phi1:=f12;phi2:=f21;
			  end;
			 if abs(f22-f11-2*Psi)<1e-4 then
			  begin
			  phi1:=f11;phi2:=f22 ;
			  end;
			 if abs(f22-f12-2*Psi)<1e-4 then
			  begin
			  phi1:=f12;phi2:=f22 ;;
			  end;


			 if abs(f21-f11-2*Psi+2*pi)<1e-4 then
			  begin
			  phi1:=f11;phi2:=f21;
			  end;
			 if abs(f21-f12-2*Psi+2*pi)<1e-4 then
			  begin
			  phi1:=f12;phi2:=f21;
			  end;
			 if abs(f22-f11-2*Psi+2*pi)<1e-4 then
			  begin
			  phi1:=f11;phi2:=f22 ;
			  end;
			 if abs(f22-f12-2*Psi+2*pi)<1e-4 then
			  begin
			  phi1:=f12;phi2:=f22 ;
			  end;

			{******  Fin Calcul phi1, Phi2   *****}

			If abs(Phi1-2*pi)<1e-6 then Phi1:=0;




	END;

 {---------------------------  FIN DE PROCEDURE  CALCULS_GENERAUX  ---------------------------------------}



 {---------------------- DEBUT DE PROCEDURE  CLASSIFICATION_CAS ELLIPTIQUE --------------------------------}

 PROCEDURE  CLASSIFICATION_CAS(Var phi1,phi2,Lambda,R1,R2:real);
	Var E1,E2,E3,E4,E5,E6:boolean;

  BEGIN
         { CAS ELLIPTIQUES }

      CAS_DE_VOL:=666; { ***  Pour dtecter les cas oublis ou mal dfinis ****}

      if exc<1 then
        begin
	 E1:=(R1<=R2);E2:=(Lambda>0);E3:=(Phi1<=pi);E4:=(Phi2<=pi);E5:=(Phi1<Phi2);


         If (E1 and E2 and E3 and E4 and E5) then CAS_DE_VOL:=1;
	 If (E1 and E2 and E3 and Not(E4) and E5) then CAS_DE_VOL:=2;
	 If (E1 and NOT(E2) and E3 and NOT(E4) and E5) then CAS_DE_VOL:=3;
	 If (E1 and NOT(E2) and NOT(E3) and NOT(E4) and NOT(E5)) then CAS_DE_VOL:=4;
	 If (E1 and NOT(E2) and NOT(E3) and E4 and NOT(E5)) then CAS_DE_VOL:=5;
	 If (NOT(E1) and E2 and E3 and NOT(E4) and E5) then CAS_DE_VOL:=6;
	 If (NOT(E1) and E2 and NOT(E3) and NOT(E4) and E5) then CAS_DE_VOL:=7;
	 If (NOT(E1) and NOT(E2) and E3 and E4 and NOT(E5)) then CAS_DE_VOL:=8;
	 If (NOT(E1) and NOT(E2) and NOT(E3) and E4 and NOT(E5)) then CAS_DE_VOL:=9;
	 If (NOT(E1) and E2 and NOT(E3) and E4 and NOT(E5)) then CAS_DE_VOL:=10;
         If (NOT(E1) and NOT(E2) and E3 and NOT(E4) and E5) then CAS_DE_VOL:=11;
         If (E1 and E2 and NOT(E3) and E4 and NOT(E5)) then CAS_DE_VOL:=12;

         If Ntour=0 then WriteLn('     LE CAS DE VOL EST ELLIPTIQUE SIMPLE DE N = ', CAS_DE_VOL);
         If Ntour>0 then WriteLn('     LE CAS DE VOL EST ELLIPTIQUE A ',NTOUR,' TOURS DE N = ', CAS_DE_VOL);
       end;

       

         { CAS HYPERBOLIQUES }

       if exc>1 then
        begin
         E1:=(R1<=R2);E2:=(Lambda>0);E3:=(Phi1<0);E4:=(Phi2<0);E5:=(Phi1<Phi2);

        
         If ((E1) and NOT(E2) and (E3) and NOT(E4) and (E5)) then CAS_DE_VOL:=13;
         If (NOT(E1) and E2 and (E3) and (E4) and (E5)) then CAS_DE_VOL:=14;
         If (NOT(E1) and E2 and (E3) and NOT(E4) and (E5)) then CAS_DE_VOL:=15;
         If (NOT(E1) and NOT(E2) and (E3) and NOT((E4)) and (E5)) then CAS_DE_VOL:=16;
         If ((E1) and E2 and NOT(E3) and NOT(E4) and (E5)) then CAS_DE_VOL:=17;
         If ((E1) and E2 and (E3) and NOT(E4) and (E5)) then CAS_DE_VOL:=18;

         WriteLn('     LE CAS DE VOL EST HYPERBOLIQUE DE CAS DE VOL N= ', CAS_DE_VOL);
       end;

       
	 

  END;
 {---------------------------  FIN DE PROCEDURE  CLASSIFICATION DES CAS  ---------------------------------------}


  {---------------------------  DEBUT DE PROCEDURE  PARAMETRES_ORBITAUX_ELLIPTIQUE  --------------------------}

  PROCEDURE  PARAMETRES_ORBITAUX_ELLIPTIQUE;
  {VectNod,VectExc,Vitesse1,Vitesse2:vecteur;}

  Var Radial,OrthoRadial,CV1,CV2,CV3,CV4,CV5:Vecteur;
		Cst,NVitesse1,NVitesse2:Real;
  BEGIN
	  Cteta1:=(cos(Phi1)-Exc)/(1-Exc*cos(Phi1));
	  STeta1:=DemiAxe/R1*sqrt(1-sqr(Exc))*sin(Phi1);

	  {-------------  Vitesse 1  --------------------}
	  Cst:=sqrt(Mu/DemiAxe/(1-sqr(Exc)));
	  ScalVect(1/norm(W),W,AxeW);
	  Scalvect(1/R1,RayonVecteurDepart,Radial);
	  ProdVect(AxeW,Radial,Orthoradial);
	  Scalvect(Cst*Exc*STeta1,Radial,CV2);
	  Scalvect(Cst*(1+Exc*CTeta1),OrthoRadial,CV3);

	  Somme(CV2,CV3,Vitesse1);
	  NVitesse1:=Norm(Vitesse1);
	  

	  {------------- FIN  Vitesse 1  ----------------}


	  Cteta2:=(cos(Phi2)-Exc)/(1-Exc*cos(Phi2));
	  STeta2:=DemiAxe/R2*sqrt(1-sqr(Exc))*sin(Phi2);

	  {-------------  Vitesse 2  --------------------}
	  Cst:=sqrt(Mu/DemiAxe/(1-sqr(Exc)));
	  ScalVect(1/norm(W),W,AxeW);
	  Scalvect(1/R2,RayonVecteurDepart,Radial2);
	  ProdVect(AxeW,Radial,Orthoradial2);
	  Scalvect(Cst*Exc*STeta2,Radial2,CV2);
	  Scalvect(Cst*(1+Exc*CTeta2),OrthoRadial2,CV3);

	  Somme(CV2,CV3,Vitesse2);
	  NVitesse2:=Norm(Vitesse2);


	  {------------- FIN  Vitesse 2  ----------------}

	  {--------------  Vecteur Excentricit VectExc -------------------}

	  {Moment cintique}   Prodvect(RayonVecteurDepart,Vitesse1,CV2);
	  ProdVect(Vitesse1,CV2,CV3);
	  ScalVect(1/Mu,CV3,CV4);
	  ScalVect(-1/R1,RayonVecteurDepart,CV5);
	  Somme(CV4,CV5,VectExc);

	  {-------------- FIN Vecteur Excentricit VectExc ----------------}

	  {Inclinaison} Inclinaison:=ArcCos(AxeW[3]);

	  {------------   Vecteur Nodal VectNod unitaire-------------------}

	  ProdVect(AxeK,AxeW,VectNod);
	  If Abs(Inclinaison)<1e-5 Then
	  Begin
		 WriteLn('    L''INCLINAISON EST NULLE  La LONGITUDE VERNALE EST PRISE NULLE');
		 LongitudeVernale:=0;
		 VectNod:=AxeI;
	  End;

	  If Abs(Inclinaison)>3e-4 Then
	  Begin
       ScalVect(1/Norm(VectNod),VectNod, VectNod);
		 LongitudeVernale:=ArcCos(VectNod[1]);
		 If VectNod[2]<0 Then   LongitudeVernale:=2*pi-LongitudeVernale;
	  End;

	 {------------FIN DE Vecteur Nodal VectNod ----------------}

	 { --------  Dbut Argument du prige -----------}

	 ArgPerigee:=ArcCos((ProdScal(VectExc,VectNod))/Exc);
	 If VectExc[3]<0 Then   ArgPerigee:=2*pi-ArgPerigee;

	 { -------- Fin  Argument du prige -----------}

	  Cteta2:=(cos(Phi2)-Exc)/(1-Exc*cos(Phi2));
	  STeta2:=DemiAxe/R2*sqrt(1-sqr(Exc))*sin(Phi2);

	  {-------------  Vitesse 2  --------------------}
	  Cst:=sqrt(Mu/DemiAxe/(1-sqr(Exc)));
	  ScalVect(1/norm(W),W,AxeW);
	  Scalvect(1/R2,RayonVecteurArrivee,Radial2);
	  ProdVect(AxeW,Radial2,Orthoradial2);
	  Scalvect(Cst*Exc*STeta2,Radial2,CV2);
	  Scalvect(Cst*(1+Exc*CTeta2),OrthoRadial2,CV3);

	  Somme(CV2,CV3,Vitesse2);
	  NVitesse2:=Norm(Vitesse2);


	  {------------- FIN  Vitesse 2  ----------------}

  END;

  {---------------------------  FIN DE PROCEDURE  PARAMETRES_ORBITAUX_ELLIPTIQ0UE  -------------------------}

  {---------------------------  DEBUT DE PROCEDURE  SORTIE_RESULTATS    -------------------------}
  PROCEDURE SORTIE_RESULTATS;

  Label fin;

  VAR ligne,TexteDuree,chaine,chaine1,chaine2:string;
		i,longueur:integer;
		Rien:real;
  BEGIN

  If helios=1 Then Texte[5]:='  VOL HELIOCENTRIQUE';
  If helios=0 Then Texte[5]:='  VOL GEOCENTRIQUE';
  If helios=2 Then Texte[5]:='  VOL AUTOUR DE MARS';
  If helios=3 Then Texte[5]:='  VOL PLANETOCENTRIQUE';

  If ((W[3]>=0) and (Helios=1)) Then  Texte[6]:='  MOUVEMENT DANS LE SENS DES PLANETES';
  If (Not(W[3]>=0) and (Helios=1)) Then  Texte[6]:='  MOUVEMENT DANS LE SENS CONTRAIRE DES PLANETES';
  If ((W[3]>=0) and (Helios=0)) Then  Texte[6]:='  MOUVEMENT CIRCUMTERRESTRE A INCLINAISON<=90';
  If (Not(W[3]>=0) and (Helios=0)) Then  Texte[6]:='  MOUVEMENT CIRCUMTERRESTRE A INCLINAISON>90';

  If ((W[3]>=0) and (Helios=2)) Then  Texte[6]:='  MOUVEMENT AUTOUR DE MARS A INCLINAISON<=90';
  If (Not(W[3]>=0) and (Helios=2)) Then  Texte[6]:='  MOUVEMENT AUTOUR DE MARS A INCLINAISON>90';

  If ((W[3]>=0) and (Helios=3)) Then  Texte[6]:='  MOUVEMENT PLANETOCENTRIQUE A INCLINAISON<=90';
  If (Not(W[3]>=0) and (Helios=3)) Then  Texte[6]:='  MOUVEMENT PLANETOCENTRIQUE A INCLINAISON>90';

  If Lambda>=0 Then Texte[7]:='  VOL COURT AVEC BALAYAGE ANGULAIRE FINAL <= 180';
  If Lambda<0 Then Texte[7]:='  VOL LONG AVEC BALAYAGE ANGULAIRE FINAL > 180';

  If NTour>0 Then
	 begin
	  Str(NTour,Ligne);
	  Texte[8]:=Concat('  LE VOYAGE EFFECTUE ',Ligne);
	  Texte[8]:=Concat(Texte[8],' TOUR(S) COMPLET(S) AVANT RENDEZ-VOUS');
	 end;
  WriteLn(Texte[8]);

  If ((Inclinaison=0) and (Helios=1)) then  Texte[9]:='  ORBITE DANS L''ECLIPTIQUE';
  If ((Inclinaison=0) and (Helios=0))then  Texte[9]:='  ORBITE TERRESTRE EQUATORIALE OU DANS LE PLAN IJ';
  If NOT((Inclinaison=0) and (Helios=0))then  Texte[9]:='';

  If Helios=1 Then
  BEGIN
	 Str(Duree:8:3,TexteDuree);
	 Texte[10]:=Concat('  DUREE CHOISIE DE CE VOYAGE : ',TexteDuree, '  jours');
  END;

  If Helios=0 Then
  BEGIN
	 duree:=Duree*86400;
	 Str(Duree:7:1,TexteDuree);
	 Texte[10]:=Concat('  DUREE CHOISIE DE CE VOYAGE : ',TexteDuree, '  secondes');
	 duree:=Duree/86400;
  END;



  Str(RayonVecteurDepart[1]:13:2,X);
  Texte[14]:=Concat('     X en km, X = ',X,  ' km');
  Str(RayonVecteurDepart[2]:13:2,X);
  Texte[15]:=Concat('     Y en km, Y = ',X,  ' km');
  Str(RayonVecteurDepart[3]:13:2,X);
  Texte[16]:=Concat('     Z en km, Z = ',X,  ' km');

  Str(RayonVecteurArrivee[1]:13:2,X);
  Texte[18]:=Concat('     X en km, X = ',X,  ' km');
  Str(RayonVecteurArrivee[2]:13:2,X);
  Texte[19]:=Concat('     Y en km, Y = ',X,  ' km');
  Str(RayonVecteurArrivee[3]:13:2,X);
  Texte[20]:=Concat('     Z en km, Z = ',X,  ' km');

  If NTour=0 Then Texte[23]:=' ';
  If (Ntour>0) and Not(Premiere_ecriture) Then Texte[23]:='  Premire solution';
  If (Ntour>0) and Premiere_ecriture Then Texte[23]:='  Deuxime solution';


  Str(R1:12:2,X);
  Texte[25]:=Concat('     Distance dpart R1 en km = ',X,  ' km');
  Str(R2:12:2,X);
  Texte[26]:=Concat('     Distance arrive R2 en km = ',X,  ' km');

  If helios=1 then
    Begin
      Str(DureeMini:9:4,X);
      Texte[27]:=Concat('     Duree minimale d''un voyage elliptique = ',X,  ' jours');
    End;
  If helios=0 then
    Begin
      DureeMini:=DureeMini*86400;
      Str(DureeMini:10:1,X);
      Texte[27]:=Concat('     Duree minimale d''un voyage elliptique = ',X,  ' secondes');
      DureeMini:=DureeMini/86400;
    End;

  If Duree<DureeMini then  Texte[28] := '     VOTRE VOYAGE SERA HYPERBOLIQUE';
  If Duree>=DureeMini then  Texte[28] := '     VOTRE VOYAGE SERA ELLIPTIQUE';

  { ------------  ORBITE ------------}

  RayonPerigee:=DemiAxe*(1-exc);
  If duree<dureemini then  RayonPerigee:=- RayonPerigee;
  RayonApogee:=DemiAxe*(1+exc);
  Str(RayonPerigee:9:0,X);
  Texte[29]:=Concat('     Rayon vecteur prige Rp= ',X,  ' km');
  Str(RayonApogee:9:0,X);
  Texte[30]:=Concat('     Rayon vecteur apogee Ra= ',X,  ' km');
  If duree<dureemini then Texte[30]:='';

  If Exc<1 then
  Begin
    Phi1:=Phi1*180/pi;Phi2:=Phi2*180/pi;
    Str(Phi1:7:3,X);
    Texte[31]:=Concat('     Anomalie excentrique dpart fi1= ',X,  ' degrs');
    Str(Phi2:7:3,X);
    Texte[32]:=Concat('     Anomalie excentrique arrive fi2= ',X,  ' degrs');
  End;

   If Exc>=1 then
   Begin
      Phi1:=Phi1;Phi2:=Phi2;
      Str(Phi1:7:3,X);
      Texte[31]:=Concat('     Anomalie excentrique dpart fi1 = ',X,' (sans dim)');
      Str(Phi2:7:3,X);
      Texte[32]:=Concat('     Anomalie excentrique arrive fi2 (sans dim)= ',X,' (sans dim)');
   End;

  If Exc<1 then
  Begin
     Str(CAS_DE_VOL:2,X);
     Texte[33]:=Concat('     VOYAGE ELLIPTIQUE: CAS DE VOL N  ',X);
     Texte[35]:=Concat('     VOYAGE ELLIPTIQUE: CAS DE VOL N  ',X);;
  End;

  If Exc>=1 then
  Begin
     Str(CAS_DE_VOL:2,X);
     Texte[33]:=Concat('     VOYAGE HYPERBOLIQUE: CAS DE VOL  N  ',X);
     Texte[35]:=Concat('     VOYAGE HYPERBOLIQUE: CAS DE VOL  N  ',X);;
  End;


  If duree<dureemini then Texte[33]:='';
  Str(DemiAxe:12:2,X);
  Texte[36]:=Concat('     Demi grand-axe a = ',X, ' km');

  Str(Exc:7:5,X);
  Texte[37]:=Concat('     Excentricit e = ',X);

  LongitudeVernale:=LongitudeVernale*180/pi;
  Str(LongitudeVernale:7:3,X);
  Texte[38]:=Concat('     Longitude Vernale GW= ',X, ' degrs');

  ArgPerigee:=ArgPerigee*180/pi;
  Str(ArgPerigee:7:3,X);
  Texte[39]:=Concat('     Argument Nodal du prige pw= ',X, ' degrs');

  Inclinaison:=Inclinaison*180/pi;
  Str(Inclinaison:7:3,X);
  Texte[40]:=Concat('     Inclinaison i= ',X, ' degrs');

  If exc <1 then
  Begin
    teta1:=ArcCos(CTeta1)*180/pi;
    If phi1>180 then Teta1:=360-Teta1;
    Str(Teta1:7:3,X);
    Texte[41]:=Concat('     Anomalie vraie du dpart Tta1 = ',X, ' degrs');
  End;

  If exc >=1 then
  Begin
    teta1:=ArcCos(CTeta1)*180/pi;
    If phi1<0 then Teta1:=-Teta1;
    Str(Teta1:7:3,X);
    Texte[41]:=Concat('     Anomalie vraie du dpart Tta1 = ',X, ' degrs');
  End;

  {----------------------------------}

  {  -------------  VITESSES DEPART-ARRIVEE --------------}



	 Str(Vitesse1[1]:7:4,X);
	 Texte[46]:=Concat('     Sur I : V1X = ',X, ' km/s');
	 Str(Vitesse1[2]:7:4,X);
	 Texte[47]:=Concat('     Sur J : V1Y = ',X, ' km/s');
	 Str(Vitesse1[3]:7:4,X);
	 Texte[48]:=Concat('     Sur K : V1Z = ',X, ' km/s');

	 NormeV1:=Norm(Vitesse1);
	 Str(NormeV1:7:4,X);
	 Texte[49]:=Concat('     NORME DE LA VITESSE ABSOLUE V1 = ',X, ' km/s');



	 Str(Vitesse2[1]:7:4,X);
	 Texte[52]:=Concat('     Sur I : V2X = ',X, ' km/s');
	 Str(Vitesse2[2]:7:4,X);
	 Texte[53]:=Concat('     Sur J : V2Y = ',X, ' km/s');
	 Str(Vitesse2[3]:7:4,X);
	 Texte[54]:=Concat('     Sur K : V2Z = ',X, ' km/s');

	 NormeV2:=Norm(Vitesse2);
	 Str(NormeV2:7:4,X);
	 Texte[55]:=Concat('     NORME DE LA VITESSE ABSOLUE V2 = ',X, ' km/s');



  { ------------------------------------------------------}

  {---------------------------------------------------------------------------------------------}
        { MISE EN FORME DU TITRE DES SORTIES }

        If Length(titremission)=0 then titre:=Concat('RECAPITULATIF DU DERNIER CALCUL',': ',Nomdepart,' - ',Nomarrivee);
        If Length(titremission)>0 then titre:=Titremission;

        chaine:='                       ';
        longueur:= Round(Int((76-length(titre))/2));
        chaine1:=Copy(chaine,1,longueur);
        chaine2:='*'+chaine1+titre;
        longueur:=Round(77-length(chaine2));
        chaine1:=Copy(chaine,1,longueur);
        chaine2:=chaine2+chaine1+'*';

	Texte[1]:='******************************************************************************';
	Texte[2]:='*                   RECAPITULATIF DU DERNIER CALCUL                          *';
        Texte[2]:=chaine2;
	Texte[3]:='******************************************************************************';
	Texte[4]:= '------------------- CONDITIONS DE VOL CHOISIES --------------------------';
	{Texte[5]:='  VOL HELIOCENTRIQUE';
	Texte[6]:='  MOUVEMENT DANS LE SENS DES PLANETES';
	Texte[7]:='  VOL COURT AVEC BALAYAGE ANGULAIRE < 180';
	Texte[8]:='  LE VOYAGE EFFECTUE 2 TOURS COMPLETS AVANT RENDEZ-VOUS';
	Texte[9]:='  ORBITE DANS L'' ECLIPTIQUE';
	Texte[10]:='  DUREE CHOISIE DE CE VOYAGE, EN JOURS : 957'; }
	Texte[11]:=' -----------------------------------------------------------------------------';
	Texte[12]:=' --------------------- LES POINTS A RELIER -----------------------------------';
	Texte[13]:=' POINT DE DEPART P1 ( Coordonnes en km ) :';
	{Texte[14]:='     X= 150000000 km';
	Texte[15]:='     Y= 0 km';
	Texte[16]:='     Z= 0 km'; }
	Texte[17]:=' POINT D''ARRIVEE P2 ( Coordonnes en km ) :';
	{Texte[18]:='     X= 150000000 km';
	Texte[19]:='     Y= 0 km';
	Texte[20]:='     Z= 0 km';}
	Texte[21]:=' -----------------------------------------------------------------------------';
	Texte[22]:=' oooooooooo NOTEZ ET APPUYEZ SUR UNE TOUCHE POUR CONTINUER oooooooooooooooooo';
	{Texte[23]:=' ';}
	Texte[24]:=' *-*-*-*-*-*-*-*-*-*-*-* RESULTATS DU CALCUL *-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*';
  {Texte[25]:='     Distance R1 en km';
	Texte[26]:='     Distance R2 en km';
	Texte[27]:='     Dure minimale du voyage, en jours : 90.0124')
	Texte[28]:='     VOTRE VOYAGE SERA ELLIPTIQUE';
	Texte[29]:='     Rayon vecteur prige =124578 km';
	Texte[30]:='     Rayon vecteur apoge =124578 km';
	Texte[31]:='     Anomalie excentrique du dpart en degrs fi1=123';
	Texte[32]:='     Anomalie excentrique arrive en degrs fi1=123';
	Texte[33]:='     CAS ELLIPTIQUE N 5';}
	Texte[34]:=' ------------------------- PARAMETRES ORBITAUX --------------------------	-----';
	{Texte[35]:='  ';}
  {Texte[36]:='     Demi-grand axe a = 45200000 km';
	Texte[37]:='     Excentricit e =0.23154 ';
	Texte[38]:='     Longitude vernale Grand Omga = 123';
	Texte[39]:='     Argument Nodal du prige Petit Omga = 245 ';
	Texte[40]:='     Inclinaison orbitale i = 14 ';
	Texte[41]:='     Anomalie vraie du dpart tta = 125.23 degrs'; }
	Texte[42]:=' ';
	Texte[43]:=' ------------------ VITESSES ABSOLUES DEPART-ARRIVEE -------------------------';
	Texte[44]:=  Texte[33];
	Texte[45]:='     DEPART';
	{Texte[46]:='        Sur I : V1X = 32.45 km/s';
	Texte[47]:='        Sur J : V1Y = 3.2 km/s';
	Texte[48]:='        Sur K : V1Z = 0.32 km/s';
	Texte[49]:='     DE NORME V1= 33.5 km/s';}
	Texte[50]:=' ';
	Texte[51]:='     ARRIVEE';
	{Texte[52]:='        Sur I : V2X = 32.45 km/s';
	Texte[53]:='        Sur J : V2Y = 3.2 km/s';
	Texte[54]:='        Sur K : V2Z = 0.32 km/s';
	Texte[55]:='     DE NORME V2= 33.5 km/s';    ';
	{Texte[56]:=' ------------------------------------------------------------------------------';}

	{ ---------  CAS NORMAL ---------------------}

  If ((Ntour=0) and Not(Premiere_ecriture)) then
	  BEGIN
		 ktexte:=0;
		 For i:= 1 to 100 do
		  Begin
			If length(texte[i])>0 then ktexte:=i;
		  end;

		For i:=1 to ktexte do
		 Begin
			TexteFinal[i]:= texte[i];
		 end;
	  END;
  { --------- FIN  CAS NORMAL ---------------------}

  { --------------- CAS N TOURS -------------------}

  { Premire solution *}

  If ((Ntour>0) and Not(Premiere_ecriture)) then
	  BEGIN

		For i:= 1 to 100 do
		  Begin
			If length(texte[i])>0 then ktexte:=i;
		  end;

		For i:=1 to ktexte do
		 Begin
			TexteFinal[i]:= texte[i];
		 end;

  END;

  { Fin Premire solution * }

  { Deuxieme solution *}

	If (Ntour>0) and Premiere_ecriture then
	  BEGIN
	  For i:=23 to ktexte do
		 Begin
			TexteFinal[ktexte+i-22]:= texte[i];
		 end;
	  END;

	  { Fin Deuxieme solution *}
  {---------------------------------------------------------------------------------------------}

  FIN:
  END;

  {---------------------------  FIN DE PROCEDURE  SORTIE_RESULTATS    -------------------------}

  {----------------------------- DEBUT PROCEDURE ECRITURE_ECRAN -------------------------------}
  PROCEDURE ECRITURE_ECRAN;

  Var i:Integer;

  BEGIN
  WriteLn;
  WriteLn(' ********* ATTENTION EFFACEMENT ECRAN AVANT RECAPITULATION **************');
  WriteLn('                         APPUYEZ SUR UNE TOUCHE ');ch:=readkey;
  clrScr;
  WriteLn;

  { -----------  CAS NORMAL --------------}

 If NTour=0 then
 BEGIN
  For i:= 1 to 22 do
	  Begin
		WriteLn(TexteFinal[i]);
	  end;
  ch:=readkey;
  For i:= 23 to 33 do
	  Begin
		WriteLn(TexteFinal[i]);
	  end;
  ch:=readkey;

  For i:= 34 to 42 do
	  Begin
		WriteLn(TexteFinal[i]);
	  end;
  ch:=readkey;
  For i:= 43 to ktexte do
	  Begin
		WriteLn(TexteFinal[i]);
	  end;
 END;

 { ----------- FIN DU  CAS NORMAL --------------}


 { ---- CAS SPECIAL A 2 SOLUTIONS ----- }

 If NTour>0 then
 BEGIN

	  For i:= 1 to 22 do
	  Begin
		WriteLn(TexteFinal[i]);
	  end;
  ch:=readkey;
  For i:= 23 to 33 do
	  Begin
		WriteLn(TexteFinal[i]);
	  end;
  ch:=readkey;

  For i:= 34 to 42 do
	  Begin
		WriteLn(TexteFinal[i]);
	  end;
  ch:=readkey;

  For i:= 43 to ktexte-33 do
	  Begin
		WriteLn(TexteFinal[i]);
	  end;
  For i:= 23 to 33 do
	  Begin
		WriteLn(TexteFinal[i+33]);
	  end;
  ch:=readkey;

  For i:= 34 to 42 do
	  Begin
		WriteLn(TexteFinal[i+33]);
	  end;
  ch:=readkey;
  For i:= 43 to 55 do
	  Begin
		WriteLn(TexteFinal[i+33]);
	  end;

  END;

  { ---- FIN CAS SPECIAL A 2 SOLUTIONS ----- }


       WriteLn;
       WriteLn(' *********************** FIN DES SORTIES **************************');
       writeLn('              Appuyez sur une touche pour continuer');
                ch:=readkey;
                WRITELN;
		WRITELN(' --------------------------------------------------------');
		WRITELN('');
		WRITELN('                   DESCRIPTION DES CAS DE VOL');
		WRITELN('  CONVENTIONS ( Redondantes ):');
		WRITELN('     P- <--> Avant prige   P+ <--> Aprs prige ');
		WRITELN('     A- <--> Avant apoge    A+ <--> Aprs Apoge ');
		WRITELN('     M- <--> Monte          D  <--> Descente');
		WRITELN('     M- <--> Monte          D  <--> Descente');
		WRITELN('     G+ <--> Angle>189      G- <--> Angle<180');

                
		WRITELN('     CAS 1 Ellipse :R1<R2 G- Dpart M & P+, Arrive M & A- ');
		WRITELN('     CAS 2 Ellipse :R1<R2 G- Dpart M & P+, Arrive D & P- & A+ ');
		WRITELN('     CAS 3 Ellipse :R1<R2 G+ Dpart M & P+, Arrive D & P- & A+ ');
		WRITELN('     CAS 4 Ellipse :R1<R2 G- Dpart D & P-, Arrive D & P- & A+ ');
		WRITELN('     CAS 5 Ellipse :R1<R2 G- Dpart D & P-, Arrive M & P+ & A- ');
		WRITELN('     CAS 6 Ellipse :R1>R2 G- Dpart M & P+, Arrive D & P- & A+ ');
		WRITELN('     CAS 7 Ellipse :R1>R2 G- Dpart D & A+, Arrive D & P- ');
		WRITELN('     CAS 8 Ellipse :R1>R2 G+ Dpart M & P+ & A-, Arrive M & P+ & A-');
		WRITELN('     CAS 9 Ellipse :R1>R2 G+ Dpart D & A+ & P-, Arrive M & P+ & A- ');
		WRITELN('     CAS 10 Ellipse  :R1>R2 G- Dpart D & A+ & P-, Arrive D & P- & A+ ');

                WRITELN('     CAS 11 Ellipse :R1>R2 G- Dpart M & P+ & A-, Arrive D & A+ & P- ');
                WRITELN('     CAS 12 Ellipse :R1<R2 G- Dpart M & P-, Arrive M & A- ');



		WRITELN('     CAS 13 Hyperbole  :R1<R2 G+ Dpart D & P-, Arrive M & P+');
		WRITELN('     CAS 14 Hyperbole  :R1>R2 G- Dpart D & P-, Arrive D & P-');
		WRITELN('     CAS 15 Hyperbole  :R1>R2 G- Dpart D & P-, Arrive M & P+');
		WRITELN('     CAS 16 Hyperbole  :R1>R2 G+ Dpart D & P-, Arrive M & P+');
                WRITELN('     CAS 17 Hyperbole  :R1<R2 G- Dpart M & P+, Arrive M & P+');
		WRITELN('     CAS 18 Hyperbole  :R1<R2 G- Dpart D & P-, Arrive M & P+');

                writeLn;
                WriteLn('    *********** Appuyez sur une touche pour continuer *********');
                ch:=readkey;
   writeLn('  ******************** RAPPEL DES PRELIMINAIRES *********************');
   writeLn;
   WriteLn('  Le logiciel rsout le PROBLEME DE LAMBERT dans tout type de ');
   WriteLn('  repres: Gocentriques quatoriaux...,Hliocentriques Ecliptiques... ');
   writeLn('  Gocentrique cliptique, Plantocentriques, Cartsien en gomtrie');
   writeLn('  pure etc...Ds lors les notions de "tir vers l''Est"," vers l''Ouest');
   writeLn('  peuvent ne plus avoir de sens gnral suivant le repre choisi.');
   writeLn('');
   writeLn('  Donc, la logique laisse l''utilisateur interprter les rsultats');
   writeLn('  bass sur un balayage du rayon vecteur et l''inclinaison orbitale i');
   writeLn('  lie par le produit scalaire h.K');
   writeLn('      VOL COURT ( balayage du rayon vecteur<=180)');
   writeLn('      VOL LONG ( balayage du rayon vecteur>=180)');
   writeLn('      INCLINAISON <=90 :');
   writeLn('           Vers l''Est en gocentrique quatorial');
   writeLn('           Sens des plantes en hliocentrique cliptique');
   writeLn('           A interprter pour les autres types de repres');
   writeLn('      INCLINAISON >90 :');
   writeLn('           Vers l''Ouest en gocentrique quatorial');
   writeLn('           Sens contraire des plantes en hliocentrique cliptique');
   writeLn('           A interprter pour les autres types de repres');
   WriteLn;


  END;

 {-------------------------------- FIN PROCEDURE ECRITURE_ECRAN------------------------------}
 { -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*}


 {---------------------------  DEBUT DE PROCEDURE  SOLUTION_EQUATION_HYPERBOLIQUE  -----------------------------------}

 PROCEDURE SOLUTION_EQUATION_HYPERBOLIQUE;

 Var TempsReduit,Xmin,Xmax,dx,Prod:real;
	  Test:boolean;
	  i:integer;
	  F,X:array[1..11] of real;


 BEGIN
 
 { -----------------------}

 TempsReduit:=Duree*86400/(sqrt(exp(3*Ln(S))/Mu/8));
 Xmax:=5; Xmin:=0.0001;Test:=True;
  
	Test:=True;
 While Test=True do
	Begin
	  If TempsHyperbole(Xmax,lambda) >=TempsReduit Then  Xmax:=Xmax+0.1;
	  If TempsHyperbole(Xmax,lambda) <TempsReduit Then  Test:=False;
	End;


	{-------  Rsolution   -------------}
 Test:=True;
 While Test=True do
  BEGIN
		dx:=(Xmax-Xmin)/10;
		For i:=1 To 11 do
		Begin
			X[i]:=Xmin+(i-1)*dx;
			F[i]:=TempsHyperbole(X[i],Lambda);
		end;
		For i:=1 To 10 do
		Begin
			Prod:=(TempsReduit-F[i])*(TempsReduit-F[i+1]);
			If Prod<=0 then
			begin
			 Xmin:=X[i] ;Xmax:=X[i+1];
			end;
		end;
	 If ((Xmax-Xmin) <1e-7) Then
	  begin
		 Sol0Tour:=(Xmax+Xmin)/2; Test:=False;
	  End;
  END;

	{-----------------------------------}

 END;
 {--------------------- FIN DE PROCEDURE  SOLUTION_EQUATION_HYPERBOLIQUE  ---------------------------------}

 {--------------------------- DEBUT DE PROCEDURE  CALCULS_GENERAUX_HYPERBOLE  ---------------------------------------}

  PROCEDURE CALCULS_GENERAUX_HYPERBOLE(Var exc,DemiAxe,Phi1,Phi2:real);

  VAR betasol,Alphasol,Psi,Phi,A,B:real;
		f11,f12,f21,f22,bidon:real;

  BEGIN

	 If NTour=0 then Alphasol:=Sol0Tour;

	 {---------------  Calcul de Phi et Psi -------- pas de pb ---}

	 Betasol:=2*Argsh(Lambda*sinh(AlphaSol/2));

	 Phi:=(AlphaSol+BetaSol)/2;
	 Psi:=(AlphaSol-BetaSol)/2;

	 writeLn('    PSI = ',psi,'    PHI = ', phi);
	 { ------------------------------------------------------------}

	 { ------- EXCENTRICITE ET DEMI GRAND AXE a ------Pas de pb ---}

	 exc:=sqrt(sqr(cosh(Phi))-sqr((R1-R2)*sinh(Phi)/D)); WriteLn('    Excentricit =', exc);
	 DemiAxe:=S/(-1+cosh(AlphaSol));  WriteLn('    Demi-Grand axe =', DemiAxe);

	 {-------------------------------------------------------------}

	 			 
			 f11:=Argch((1+R1/DemiAxe)/exc);
			 f12:=-f11;
			 f21:=Argch((1+R2/DemiAxe)/exc);
			 f22:=-f21;
    

			 {-------- Cot >0  -----------}

			 if abs(f21-f11-2*Psi)<1e-4 then
			  begin
			  phi1:=f11;phi2:=f21;
			  end;
			 if abs(f21-f12-2*Psi)<1e-4 then
			  begin
			  phi1:=f12;phi2:=f21;
			  end;
			 if abs(f22-f11-2*Psi)<1e-4 then
			  begin
			  phi1:=f11;phi2:=f22 ;
			  end;
			 if abs(f22-f12-2*Psi)<1e-4 then
			  begin
			  phi1:=f12;phi2:=f22 ;
			  end;
			{-------------------------------}

          

			{******  Fin Calcul phi1, Phi2   *****}
    
	END;

 {---------------------------  FIN DE PROCEDURE  CALCULS_GENERAUX_HYPERBOLE  ---------------------------------------}


 {---------------------------  DEBUT PROCEDURE PARAMETRES_ORBITAUX_HYPERBOLIQUE -------------}

  PROCEDURE  PARAMETRES_ORBITAUX_HYPERBOLIQUE;
  
  Var Radial,OrthoRadial,CV1,CV2,CV3,CV4,CV5:Vecteur;
		Cst,NVitesse1,NVitesse2,tan:Real;
  BEGIN
	  tan:=puiss(((exc+1)/(exc-1)),0.5)*sinh(Phi1/2)/cosh(Phi1/2);
          Cteta1:=(1-tan*tan)/(1+tan*tan);
          Steta1:=2*tan/(1+tan*tan);

          tan:=puiss(((exc+1)/(exc-1)),0.5)*sinh(Phi2/2)/cosh(Phi2/2);
          Cteta2:=(1-tan*tan)/(1+tan*tan);
          Steta2:=2*tan/(1+tan*tan);

	  {-------------  Vitesse 1  --------------------}
	  Cst:=sqrt(Mu/DemiAxe/(sqr(Exc)-1));
	  ScalVect(1/norm(W),W,AxeW);
	  Scalvect(1/R1,RayonVecteurDepart,Radial);
	  ProdVect(AxeW,Radial,Orthoradial);
	  Scalvect(Cst*Exc*STeta1,Radial,CV2);
	  Scalvect(Cst*(1+Exc*CTeta1),OrthoRadial,CV3);

	  Somme(CV2,CV3,Vitesse1);
	  NVitesse1:=Norm(Vitesse1);


	  {------------- FIN  Vitesse 1  ----------------}


	  Cteta2:=(cosh(Phi2)-Exc)/(1-Exc*cosh(Phi2));
	  STeta2:=DemiAxe/R2*sqrt(sqr(Exc)-1)*sinh(Phi2);

	  {-------------  Vitesse 2  --------------------}
	  Cst:=sqrt(Mu/DemiAxe/(sqr(Exc)-1));
	  ScalVect(1/norm(W),W,AxeW);
	  Scalvect(1/R2,RayonVecteurDepart,Radial2);
	  ProdVect(AxeW,Radial,Orthoradial2);
	  Scalvect(Cst*Exc*STeta2,Radial2,CV2);
	  Scalvect(Cst*(1+Exc*CTeta2),OrthoRadial2,CV3);

	  Somme(CV2,CV3,Vitesse2);
	  NVitesse2:=Norm(Vitesse2);


	  {------------- FIN  Vitesse 2  ----------------}

	  {--------------  Vecteur Excentricit VectExc -------------------}

	  {Moment cintique}   Prodvect(RayonVecteurDepart,Vitesse1,CV2);
	  ProdVect(Vitesse1,CV2,CV3);
	  ScalVect(1/Mu,CV3,CV4);
	  ScalVect(-1/R1,RayonVecteurDepart,CV5);
	  Somme(CV4,CV5,VectExc);

	  {-------------- FIN Vecteur Excentricit VectExc ----------------}

	  {Inclinaison} Inclinaison:=ArcCos(AxeW[3]);

	  {------------   Vecteur Nodal VectNod unitaire-------------------}

	  ProdVect(AxeK,AxeW,VectNod);
	  If Abs(Inclinaison)<1e-5 Then
	  Begin
		 WriteLn('     L''INCLINAISON EST NULLE  La LONGITUDE VERNALE EST PRISE NULLE');
		 LongitudeVernale:=0;
		 VectNod:=AxeI;
	  End;

	  If Abs(Inclinaison)>3e-4 Then
	  Begin
		 ScalVect(1/Norm(VectNod),VectNod, VectNod);
		 LongitudeVernale:=ArcCos(VectNod[1]);
		 If VectNod[2]<0 Then   LongitudeVernale:=2*pi-LongitudeVernale;
	  End;

	 {------------FIN DE Vecteur Nodal VectNod ----------------}

	 { --------  Dbut Argument du prige -----------}

	 ArgPerigee:=ArcCos((ProdScal(VectExc,VectNod))/Exc);
	 If VectExc[3]<0 Then   ArgPerigee:=2*pi-ArgPerigee;

	 { -------- Fin  Argument du prige -----------}


	  {-------------  Vitesse 2  --------------------}
	  Cst:=sqrt(Mu/DemiAxe/(sqr(Exc)-1));
	  ScalVect(1/norm(W),W,AxeW);
	  Scalvect(1/R2,RayonVecteurArrivee,Radial2);
	  ProdVect(AxeW,Radial2,Orthoradial2);
	  Scalvect(Cst*Exc*STeta2,Radial2,CV2);
	  Scalvect(Cst*(1+Exc*CTeta2),OrthoRadial2,CV3);

	  Somme(CV2,CV3,Vitesse2);
	  NVitesse2:=Norm(Vitesse2);


	  {------------- FIN  Vitesse 2  ----------------}

  END;


 {----------------------------  FIN DE PROCEDURE PARAMETRES_ORBITAUX_HYPERBOLIQUE -------------}


 {---------------------------  DEBUT DE PROCEDURE  CLASSIFICATION_CAS_HYPERBOLIQUES ---------------------------------------}

 PROCEDURE  CLASSIFICATION_CAS_HYPERBOLIQUE(Var phi1,phi2,Lambda,R1,R2:real);
	Var E1,E2,E3,E4,E5,E6:boolean;

  BEGIN
	 E1:=(R1<=R2);E2:=(Lambda>0);E3:=(Phi1>0);E4:=(Phi2>0);

	 
         If (E1 and NOT(E2) and NOT(E3) and E4) then CAS_DE_VOL:=13;
	 If (NOT(E1) and E2 and NOT(E3) and NOT(E4)) then CAS_DE_VOL:=14;
	 If (NOT(E1) and E2 and NOT(E3) and E4 ) then CAS_DE_VOL:=15;
	 If (NOT(E1) and NOT(E2) and Not(E3) and E4) then CAS_DE_VOL:=16;
         If (E1 and E2 and E3 and E4 and E5) then CAS_DE_VOL:=17;
	 If (E1 and E2 and Not(E3) and E4) then CAS_DE_VOL:=18;

	 If Ntour=0 then WriteLn('     LE CAS DE VOL EST HYPERBOLIQUE CAS N = ', CAS_DE_VOL);


  END;
 {---------------------------  FIN DE PROCEDURE  CLASSIFICATION DES CAS HYPERBOLIQUES ---------------------------------------}




 { *******************************  PROGRAMME PRINCIPAL  *************************************}

BEGIN
DEBUT_LOGIQUE:
        ECRITURE_FICHIER_PRELIMINAIRES;
	Premiere_ecriture:=False;
       	DEMANDES;
	INITIALISATION;
	SOLUTION_ELLIPTIQUE;
	If ((DureeMini<=Duree) and (NTour=0)) Then
	 BEGIN
		SOLUTION_EQUATION_ELLIPTIQUE_0_TOUR;
		WriteLn('     **************************************************************************');
		WriteLn('     Solution Lambert  moins de 1 tour de ',duree:7:2,' jours :Alpha= ',Sol0tour:7:5,' rd');
		WriteLn('     **************************************************************************');

		CALCULS_GENERAUX_ELLIPSE(exc,DemiAxe,Phi1,Phi2);
		CLASSIFICATION_CAS(phi1,phi2,Lambda,R1,R2);
		PARAMETRES_ORBITAUX_ELLIPTIQUE;
		SORTIE_RESULTATS; ch:=readkey;

	 END;

	{ ---------------------------- Premire solution  plus de 1 tour  --------------------------------}


	 If ((DureeMiniN<=Duree) and (NTour>0) and not(Premiere_ecriture)) Then
	 BEGIN
		PREMIERE_SOLUTION_EQUATION_ELLIPTIQUE_N_TOUR;
		WriteLn('     **************************************************************************');
		WriteLn('     Premire solution  plus de 1 tour de ',duree:7:2,' jours :Alpha= ',SolNtour:7:5,' rd');
		WriteLn('     **************************************************************************');
		CALCULS_GENERAUX_ELLIPSE(exc,DemiAxe,Phi1,Phi2);
		CLASSIFICATION_CAS(phi1,phi2,Lambda,R1,R2);
		PARAMETRES_ORBITAUX_ELLIPTIQUE;
		SORTIE_RESULTATS;
		Premiere_ecriture:=True;
	 END;

	 { ---------------------------- Deuxime solution  plus de 1 tour  --------------------------------}

	 If ((DureeMiniN<=Duree) and (NTour>0) and Premiere_ecriture) Then
	 BEGIN
		DEUXIEME_SOLUTION_EQUATION_ELLIPTIQUE_N_TOUR;
		WriteLn('     **************************************************************************');
		WriteLn('     Deuxime solution  plus de 1 tour de ',duree:7:2,' jours :Alpha= ',SolNtour:7:5,' rd');
		WriteLn('     **************************************************************************');
		CALCULS_GENERAUX_ELLIPSE(exc,DemiAxe,Phi1,Phi2);
		Writeln('     Phi1= ',Phi1);WriteLn('     Phi2 = ',Phi2);
		CLASSIFICATION_CAS(phi1,phi2,Lambda,R1,R2);
		PARAMETRES_ORBITAUX_ELLIPTIQUE;
		SORTIE_RESULTATS;
	 END;

	 {-------------------------------  VOL HYPERBOLIQUE  --------------------------------------}

	If DureeMini>Duree  Then
     BEGIN
	    SOLUTION_EQUATION_HYPERBOLIQUE; ch:=readkey;
		 WriteLn('     **************************************************************************');
		 WriteLn('     Solution hyperbolique du vol de ',duree:7:2,' jours :Alpha= ',Sol0tour:7:5,' rd');
		 WriteLn('     **************************************************************************');
		 CALCULS_GENERAUX_HYPERBOLE(exc,DemiAxe,Phi1,Phi2);
		 CLASSIFICATION_CAS_HYPERBOLIQUE(phi1,phi2,Lambda,R1,R2);
		 PARAMETRES_ORBITAUX_HYPERBOLIQUE;
		 SORTIE_RESULTATS;
		 ch:=readkey;
	  END;
    
	 { -----------------------------  SORTIES /FICHIER ET ECRAN -------------------------------------------}

	 If EcrireFichier then ECRITURE_FICHIER;
	 ch:=readkey;
	 ECRITURE_ECRAN;
    		
	 {-----------------------------------------------------------------------------------------------------}
         Write(' VOULEZ-VOUS EFFECTUER UN AUTRE VOYAGE DE LAMBERT ? (o/n)');ReadLn(retour);
         if retour='o'  then goto DEBUT_LOGIQUE;
         if not(retour='o')  then
           begin
           writeLn;
             writeLn('    ***************** Terminer en appuyant sur une touche ****************');
             ch:=readKey;
	     DoneWinCrt;
           end;
	 { --------------------------  Fin du programme en appuyant sur une touche -----------------------------}
   
	

END.

{************************************** FIN FIN FIN FIN FIN FIN ****************************************}
